Loading...
Searching...
No Matches
juce::Colour Class Referencefinal

## Detailed Description

Represents a colour, also including a transparency value.

The colour is stored internally as unsigned 8-bit red, green, blue and alpha values.

The documentation for this class was generated from the following file:

- juce_graphics/colour/juce_Colour.h

## Public Member Functions

| Colour ()=default
| Creates a transparent black colour.
| Colour (const Colour &)=default
| Creates a copy of another Colour object.
| Colour (uint32 argb) noexcept
| Creates a colour from a 32-bit ARGB value.
| Colour (uint8 red, uint8 green, uint8 blue) noexcept
| Creates an opaque colour using 8-bit red, green and blue values.
| Colour (uint8 red, uint8 green, uint8 blue, uint8 alpha) noexcept
| Creates a colour using 8-bit red, green, blue and alpha values.
| Colour (uint8 red, uint8 green, uint8 blue, float alpha) noexcept
| Creates a colour from 8-bit red, green, and blue values, and a floating-point alpha.
| Colour (float hue, float saturation, float brightness, uint8 alpha) noexcept
| Creates a colour using floating point hue, saturation and brightness values, and an 8-bit alpha.
| Colour (float hue, float saturation, float brightness, float alpha) noexcept
| Creates a colour using floating point hue, saturation, brightness and alpha values.
| Colour (PixelARGB argb) noexcept
| Creates a colour using a PixelARGB object.
| Colour (PixelRGB rgb) noexcept
| Creates a colour using a PixelRGB object.
| Colour (PixelAlpha alpha) noexcept
| Creates a colour using a PixelAlpha object.
| ~Colour ()=default
| Destructor.
Colour & | operator= (const Colour &)=default
| Copies another Colour object.
bool | operator== (const Colour &other) const noexcept
| Compares two colours.
bool | operator!= (const Colour &other) const noexcept
| Compares two colours.
uint8 | getRed () const noexcept
| Returns the red component of this colour.
uint8 | getGreen () const noexcept
| Returns the green component of this colour.
uint8 | getBlue () const noexcept
| Returns the blue component of this colour.
float | getFloatRed () const noexcept
| Returns the red component of this colour as a floating point value.
float | getFloatGreen () const noexcept
| Returns the green component of this colour as a floating point value.
float | getFloatBlue () const noexcept
| Returns the blue component of this colour as a floating point value.
PixelARGB | getPixelARGB () const noexcept
| Returns a premultiplied ARGB pixel object that represents this colour.
PixelARGB | getNonPremultipliedPixelARGB () const noexcept
| Returns an ARGB pixel object that represents this colour.
uint32 | getARGB () const noexcept
| Returns a 32-bit integer that represents this colour.
uint8 | getAlpha () const noexcept
| Returns the colour's alpha (opacity).
float | getFloatAlpha () const noexcept
| Returns the colour's alpha (opacity) as a floating point value.
bool | isOpaque () const noexcept
| Returns true if this colour is completely opaque.
bool | isTransparent () const noexcept
| Returns true if this colour is completely transparent.
Colour | withAlpha (uint8 newAlpha) const noexcept
| Returns a colour that's the same colour as this one, but with a new alpha value.
Colour | withAlpha (float newAlpha) const noexcept
| Returns a colour that's the same colour as this one, but with a new alpha value.
Colour | withMultipliedAlpha (float alphaMultiplier) const noexcept
| Returns a colour that's the same colour as this one, but with a modified alpha value.
Colour | overlaidWith (Colour foregroundColour) const noexcept
| Returns a colour that is the result of alpha-compositing a new colour over this one.
Colour | interpolatedWith (Colour other, float proportionOfOther) const noexcept
| Returns a colour that lies somewhere between this one and another.
float | getHue () const noexcept
| Returns the colour's hue component.
float | getSaturation () const noexcept
| Returns the colour's saturation component.
float | getSaturationHSL () const noexcept
| Returns the colour's saturation component as represented in the HSL colour space.
float | getBrightness () const noexcept
| Returns the colour's brightness component.
float | getLightness () const noexcept
| Returns the colour's lightness component.
float | getPerceivedBrightness () const noexcept
| Returns a skewed brightness value, adjusted to better reflect the way the human eye responds to different colour channels.
void | getHSB (float &hue, float &saturation, float &brightness) const noexcept
| Returns the colour's hue, saturation and brightness components all at once.
void | getHSL (float &hue, float &saturation, float &lightness) const noexcept
| Returns the colour's hue, saturation and lightness components all at once.
Colour | withHue (float newHue) const noexcept
| Returns a copy of this colour with a different hue.
Colour | withSaturation (float newSaturation) const noexcept
| Returns a copy of this colour with a different saturation.
Colour | withSaturationHSL (float newSaturation) const noexcept
| Returns a copy of this colour with a different saturation in the HSL colour space.
Colour | withBrightness (float newBrightness) const noexcept
| Returns a copy of this colour with a different brightness.
Colour | withLightness (float newLightness) const noexcept
| Returns a copy of this colour with a different lightness.
Colour | withRotatedHue (float amountToRotate) const noexcept
| Returns a copy of this colour with its hue rotated.
Colour | withMultipliedSaturation (float multiplier) const noexcept
| Returns a copy of this colour with its saturation multiplied by the given value.
Colour | withMultipliedSaturationHSL (float multiplier) const noexcept
| Returns a copy of this colour with its saturation multiplied by the given value.
Colour | withMultipliedBrightness (float amount) const noexcept
| Returns a copy of this colour with its brightness multiplied by the given value.
Colour | withMultipliedLightness (float amount) const noexcept
| Returns a copy of this colour with its lightness multiplied by the given value.
Colour | brighter (float amountBrighter=0.4f) const noexcept
| Returns a brighter version of this colour.
Colour | darker (float amountDarker=0.4f) const noexcept
| Returns a darker version of this colour.
Colour | contrasting (float amount=1.0f) const noexcept
| Returns a colour that will be clearly visible against this colour.
Colour | contrasting (Colour targetColour, float minLuminosityDiff) const noexcept
| Returns a colour that is as close as possible to a target colour whilst still being in contrast to this one.
String | toString () const
| Returns a stringified version of this colour.
String | toDisplayString (bool includeAlphaValue) const
| Returns the colour as a hex string in the form RRGGBB or AARRGGBB.

## Static Public Member Functions

static Colour | fromRGB (uint8 red, uint8 green, uint8 blue) noexcept
| Creates an opaque colour using 8-bit red, green and blue values.
static Colour | fromRGBA (uint8 red, uint8 green, uint8 blue, uint8 alpha) noexcept
| Creates a colour using 8-bit red, green, blue and alpha values.
static Colour | fromFloatRGBA (float red, float green, float blue, float alpha) noexcept
| Creates a colour using floating point red, green, blue and alpha values.
static Colour | fromHSV (float hue, float saturation, float brightness, float alpha) noexcept
| Creates a colour using floating point hue, saturation, brightness and alpha values.
static Colour | fromHSV (float hue, float saturation, float brightness, uint8 alpha) noexcept
| Creates a colour using floating point hue, saturation, brightness values, and an 8-bit alpha.
static Colour | fromHSL (float hue, float saturation, float lightness, float alpha) noexcept
| Creates a colour using floating point hue, saturation, lightness and alpha values.
static Colour | fromHSL (float hue, float saturation, float lightness, uint8 alpha) noexcept
| Creates a colour using floating point hue, saturation, lightness values, and an 8-bit alpha.
static Colour | contrasting (Colour colour1, Colour colour2) noexcept
| Returns a colour that contrasts against two colours.
static Colour | greyLevel (float brightness) noexcept
| Returns an opaque shade of grey.
static Colour | fromString (StringRef encodedColourString)
| Reads the colour from a string that was created with toString().

## Constructors and Destructors

## Colour() [1/11]

juce::Colour::Colour | ( |  | ) |

default

Creates a transparent black colour.

Referenced by brighter(), Colour(), contrasting(), contrasting(), contrasting(), darker(), fromFloatRGBA(), fromHSL(), fromHSL(), fromHSV(), fromHSV(), fromRGB(), fromRGBA(), fromString(), greyLevel(), interpolatedWith(), operator!=(), operator=(), operator==(), overlaidWith(), withAlpha(), withAlpha(), withBrightness(), withHue(), withLightness(), withMultipliedAlpha(), withMultipliedBrightness(), withMultipliedLightness(), withMultipliedSaturation(), withMultipliedSaturationHSL(), withRotatedHue(), withSaturation(), and withSaturationHSL().

## Colour() [2/11]

juce::Colour::Colour | ( | const Colour & |  | ) |

default

Creates a copy of another Colour object.

References Colour().

## Colour() [3/11]

juce::Colour::Colour | ( | uint32 | argb | ) |

explicit noexcept

Creates a colour from a 32-bit ARGB value.

The format of this number is: ((alpha << 24) | (red << 16) | (green << 8) | blue).

All components in the range 0x00 to 0xff. An alpha of 0x00 is completely transparent, alpha of 0xff is opaque.

See also
  getPixelARGB

## Colour() [4/11]

juce::Colour::Colour | ( | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue )

noexcept

Creates an opaque colour using 8-bit red, green and blue values.

## Colour() [5/11]

juce::Colour::Colour | ( | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue,
|  | uint8 | alpha )

noexcept

Creates a colour using 8-bit red, green, blue and alpha values.

## Colour() [6/11]

juce::Colour::Colour | ( | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue,
|  | float | alpha )

noexcept

Creates a colour from 8-bit red, green, and blue values, and a floating-point alpha.

Alpha of 0.0 is transparent, alpha of 1.0f is opaque. Values outside the valid range will be clipped.

## Colour() [7/11]

juce::Colour::Colour | ( | float | hue,
|  | float | saturation,
|  | float | brightness,
|  | uint8 | alpha )

noexcept

Creates a colour using floating point hue, saturation and brightness values, and an 8-bit alpha.

The floating point values must be between 0.0 and 1.0. An alpha of 0x00 is completely transparent, alpha of 0xff is opaque. Values outside the valid range will be clipped.

## Colour() [8/11]

juce::Colour::Colour | ( | float | hue,
|  | float | saturation,
|  | float | brightness,
|  | float | alpha )

noexcept

Creates a colour using floating point hue, saturation, brightness and alpha values.

All values must be between 0.0 and 1.0. Numbers outside the valid range will be clipped.

## Colour() [9/11]

juce::Colour::Colour | ( | PixelARGB | argb | ) |

noexcept

Creates a colour using a PixelARGB object.

This function assumes that the argb pixel is not premultiplied.

## Colour() [10/11]

juce::Colour::Colour | ( | PixelRGB | rgb | ) |

noexcept

Creates a colour using a PixelRGB object.

## Colour() [11/11]

juce::Colour::Colour | ( | PixelAlpha | alpha | ) |

noexcept

Creates a colour using a PixelAlpha object.

## ~Colour()

juce::Colour::~Colour | ( |  | ) |

default

Destructor.

## Member Functions

## fromRGB()

Colour juce::Colour::fromRGB | ( | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue )

static noexcept

Creates an opaque colour using 8-bit red, green and blue values.

References Colour().

## fromRGBA()

Colour juce::Colour::fromRGBA | ( | uint8 | red,
|  | uint8 | green,
|  | uint8 | blue,
|  | uint8 | alpha )

static noexcept

Creates a colour using 8-bit red, green, blue and alpha values.

References Colour().

## fromFloatRGBA()

Colour juce::Colour::fromFloatRGBA | ( | float | red,
|  | float | green,
|  | float | blue,
|  | float | alpha )

static noexcept

Creates a colour using floating point red, green, blue and alpha values.

Numbers outside the range 0..1 will be clipped.

References Colour().

## fromHSV() [1/2]

Colour juce::Colour::fromHSV | ( | float | hue,
|  | float | saturation,
|  | float | brightness,
|  | float | alpha )

static noexcept

Creates a colour using floating point hue, saturation, brightness and alpha values.

All values must be between 0.0 and 1.0. Numbers outside the valid range will be clipped.

References Colour().

## fromHSV() [2/2]

Colour juce::Colour::fromHSV | ( | float | hue,
|  | float | saturation,
|  | float | brightness,
|  | uint8 | alpha )

static noexcept

Creates a colour using floating point hue, saturation, brightness values, and an 8-bit alpha.

All values must be between 0.0 and 1.0. An alpha of 0x00 is completely transparent, alpha of 0xff is opaque. Numbers outside the valid range will be clipped.

References Colour().

## fromHSL() [1/2]

Colour juce::Colour::fromHSL | ( | float | hue,
|  | float | saturation,
|  | float | lightness,
|  | float | alpha )

static noexcept

Creates a colour using floating point hue, saturation, lightness and alpha values.

All values must be between 0.0 and 1.0. Numbers outside the valid range will be clipped.

References Colour().

## fromHSL() [2/2]

Colour juce::Colour::fromHSL | ( | float | hue,
|  | float | saturation,
|  | float | lightness,
|  | uint8 | alpha )

static noexcept

Creates a colour using floating point hue, saturation, lightness values, and an 8-bit alpha.

All values must be between 0.0 and 1.0. An alpha of 0x00 is completely transparent, alpha of 0xff is opaque. Numbers outside the valid range will be clipped.

References Colour().

## operator=()

Colour & juce::Colour::operator= | ( | const Colour & |  | ) |

default

Copies another Colour object.

References Colour().

## operator==()

bool juce::Colour::operator== | ( | const Colour & | other | ) | const

noexcept

Compares two colours.

References Colour().

## operator!=()

bool juce::Colour::operator!= | ( | const Colour & | other | ) | const

noexcept

Compares two colours.

References Colour().

## getRed()

uint8 juce::Colour::getRed | ( |  | ) | const

inline noexcept

Returns the red component of this colour.

Returns
  a value between 0x00 and 0xff.

## getGreen()

uint8 juce::Colour::getGreen | ( |  | ) | const

inline noexcept

Returns the green component of this colour.

Returns
  a value between 0x00 and 0xff.

## getBlue()

uint8 juce::Colour::getBlue | ( |  | ) | const

inline noexcept

Returns the blue component of this colour.

Returns
  a value between 0x00 and 0xff.

## getFloatRed()

float juce::Colour::getFloatRed | ( |  | ) | const

noexcept

Returns the red component of this colour as a floating point value.

Returns
  a value between 0.0 and 1.0

## getFloatGreen()

float juce::Colour::getFloatGreen | ( |  | ) | const

noexcept

Returns the green component of this colour as a floating point value.

Returns
  a value between 0.0 and 1.0

References getFloatGreen().

Referenced by getFloatGreen().

## getFloatBlue()

float juce::Colour::getFloatBlue | ( |  | ) | const

noexcept

Returns the blue component of this colour as a floating point value.

Returns
  a value between 0.0 and 1.0

References getFloatBlue().

Referenced by getFloatBlue().

## getPixelARGB()

PixelARGB juce::Colour::getPixelARGB | ( |  | ) | const

noexcept

Returns a premultiplied ARGB pixel object that represents this colour.

References getPixelARGB().

Referenced by getPixelARGB().

## getNonPremultipliedPixelARGB()

PixelARGB juce::Colour::getNonPremultipliedPixelARGB | ( |  | ) | const

noexcept

Returns an ARGB pixel object that represents this colour.

References getNonPremultipliedPixelARGB().

Referenced by getNonPremultipliedPixelARGB().

## getARGB()

uint32 juce::Colour::getARGB | ( |  | ) | const

noexcept

Returns a 32-bit integer that represents this colour.

The format of this number is: ((alpha << 24) | (red << 16) | (green << 8) | blue).

References getARGB().

Referenced by getARGB().

## getAlpha()

uint8 juce::Colour::getAlpha | ( |  | ) | const

inline noexcept

Returns the colour's alpha (opacity).

Alpha of 0x00 is completely transparent, 0xff is completely opaque.

References getAlpha().

Referenced by getAlpha().

## getFloatAlpha()

float juce::Colour::getFloatAlpha | ( |  | ) | const

noexcept

Returns the colour's alpha (opacity) as a floating point value.

Alpha of 0.0 is completely transparent, 1.0 is completely opaque.

## isOpaque()

bool juce::Colour::isOpaque | ( |  | ) | const

noexcept

Returns true if this colour is completely opaque.

Equivalent to (getAlpha() == 0xff).

References isOpaque().

Referenced by isOpaque(), and juce::WebBrowserComponent::Options::WinWebView2::withBackgroundColour().

## isTransparent()

bool juce::Colour::isTransparent | ( |  | ) | const

noexcept

Returns true if this colour is completely transparent.

Equivalent to (getAlpha() == 0x00).

References isTransparent().

Referenced by isTransparent(), and juce::WebBrowserComponent::Options::WinWebView2::withBackgroundColour().

## withAlpha() [1/2]

Colour juce::Colour::withAlpha | ( | uint8 | newAlpha | ) | const

noexcept

Returns a colour that's the same colour as this one, but with a new alpha value.

References Colour(), and withAlpha().

Referenced by withAlpha(), and withAlpha().

## withAlpha() [2/2]

Colour juce::Colour::withAlpha | ( | float | newAlpha | ) | const

noexcept

Returns a colour that's the same colour as this one, but with a new alpha value.

References Colour(), and withAlpha().

## withMultipliedAlpha()

Colour juce::Colour::withMultipliedAlpha | ( | float | alphaMultiplier | ) | const

noexcept

Returns a colour that's the same colour as this one, but with a modified alpha value.

The new colour's alpha will be this object's alpha multiplied by the value passed-in.

References Colour(), and withMultipliedAlpha().

Referenced by withMultipliedAlpha().

## overlaidWith()

Colour juce::Colour::overlaidWith | ( | Colour | foregroundColour | ) | const

noexcept

Returns a colour that is the result of alpha-compositing a new colour over this one.

If the foreground colour is semi-transparent, it is blended onto this colour accordingly.

References Colour(), and overlaidWith().

Referenced by overlaidWith().

## interpolatedWith()

Colour juce::Colour::interpolatedWith | ( | Colour | other,
|  | float | proportionOfOther ) const

noexcept

Returns a colour that lies somewhere between this one and another.

If amountOfOther is zero, the result is 100% this colour, if amountOfOther is 1.0, the result is 100% of the other colour.

References Colour(), and interpolatedWith().

Referenced by interpolatedWith().

## getHue()

float juce::Colour::getHue | ( |  | ) | const

noexcept

Returns the colour's hue component.

The value returned is in the range 0.0 to 1.0

References getHue().

Referenced by getHue().

## getSaturation()

float juce::Colour::getSaturation | ( |  | ) | const

noexcept

Returns the colour's saturation component.

The value returned is in the range 0.0 to 1.0

References getSaturation().

Referenced by getSaturation().

## getSaturationHSL()

float juce::Colour::getSaturationHSL | ( |  | ) | const

noexcept

Returns the colour's saturation component as represented in the HSL colour space.

The value returned is in the range 0.0 to 1.0

References getSaturationHSL().

Referenced by getSaturationHSL().

## getBrightness()

float juce::Colour::getBrightness | ( |  | ) | const

noexcept

Returns the colour's brightness component.

The value returned is in the range 0.0 to 1.0

References getBrightness().

Referenced by getBrightness().

## getLightness()

float juce::Colour::getLightness | ( |  | ) | const

noexcept

Returns the colour's lightness component.

The value returned is in the range 0.0 to 1.0

References getLightness().

Referenced by getLightness().

## getPerceivedBrightness()

float juce::Colour::getPerceivedBrightness | ( |  | ) | const

noexcept

Returns a skewed brightness value, adjusted to better reflect the way the human eye responds to different colour channels.

This makes it better than getBrightness() for comparing differences in brightness.

References getPerceivedBrightness().

Referenced by getPerceivedBrightness().

## getHSB()

void juce::Colour::getHSB | ( | float & | hue,
|  | float & | saturation,
|  | float & | brightness ) const

noexcept

Returns the colour's hue, saturation and brightness components all at once.

The values returned are in the range 0.0 to 1.0

References getHSB().

Referenced by getHSB().

## getHSL()

void juce::Colour::getHSL | ( | float & | hue,
|  | float & | saturation,
|  | float & | lightness ) const

noexcept

Returns the colour's hue, saturation and lightness components all at once.

The values returned are in the range 0.0 to 1.0

References getHSL().

Referenced by getHSL().

## withHue()

Colour juce::Colour::withHue | ( | float | newHue | ) | const

nodiscard noexcept

Returns a copy of this colour with a different hue.

References Colour(), and withHue().

Referenced by withHue().

## withSaturation()

Colour juce::Colour::withSaturation | ( | float | newSaturation | ) | const

nodiscard noexcept

Returns a copy of this colour with a different saturation.

References Colour(), and withSaturation().

Referenced by withSaturation().

## withSaturationHSL()

Colour juce::Colour::withSaturationHSL | ( | float | newSaturation | ) | const

nodiscard noexcept

Returns a copy of this colour with a different saturation in the HSL colour space.

References Colour(), and withSaturationHSL().

Referenced by withSaturationHSL().

## withBrightness()

Colour juce::Colour::withBrightness | ( | float | newBrightness | ) | const

nodiscard noexcept

Returns a copy of this colour with a different brightness.

See also
  brighter, darker, withMultipliedBrightness

References Colour(), and withBrightness().

Referenced by withBrightness().

## withLightness()

Colour juce::Colour::withLightness | ( | float | newLightness | ) | const

nodiscard noexcept

Returns a copy of this colour with a different lightness.

See also
  lighter, darker, withMultipliedLightness

References Colour(), and withLightness().

Referenced by withLightness().

## withRotatedHue()

Colour juce::Colour::withRotatedHue | ( | float | amountToRotate | ) | const

nodiscard noexcept

Returns a copy of this colour with its hue rotated.

The new colour's hue is ((this->getHue() + amountToRotate) % 1.0)

See also
  brighter, darker, withMultipliedBrightness

References Colour(), and withRotatedHue().

Referenced by withRotatedHue().

## withMultipliedSaturation()

Colour juce::Colour::withMultipliedSaturation | ( | float | multiplier | ) | const

nodiscard noexcept

Returns a copy of this colour with its saturation multiplied by the given value.

The new colour's saturation is (this->getSaturation() * multiplier) (the result is clipped to legal limits).

References Colour(), and withMultipliedSaturation().

Referenced by withMultipliedSaturation().

## withMultipliedSaturationHSL()

Colour juce::Colour::withMultipliedSaturationHSL | ( | float | multiplier | ) | const

nodiscard noexcept

Returns a copy of this colour with its saturation multiplied by the given value.

The new colour's saturation is (this->getSaturation() * multiplier) (the result is clipped to legal limits).

This will be in the HSL colour space.

References Colour(), and withMultipliedSaturationHSL().

Referenced by withMultipliedSaturationHSL().

## withMultipliedBrightness()

Colour juce::Colour::withMultipliedBrightness | ( | float | amount | ) | const

nodiscard noexcept

Returns a copy of this colour with its brightness multiplied by the given value.

The new colour's brightness is (this->getBrightness() * multiplier) (the result is clipped to legal limits).

References Colour(), and withMultipliedBrightness().

Referenced by withMultipliedBrightness().

## withMultipliedLightness()

Colour juce::Colour::withMultipliedLightness | ( | float | amount | ) | const

nodiscard noexcept

Returns a copy of this colour with its lightness multiplied by the given value.

The new colour's lightness is (this->lightness() * multiplier) (the result is clipped to legal limits).

References Colour(), and withMultipliedLightness().

Referenced by withMultipliedLightness().

## brighter()

Colour juce::Colour::brighter | ( | float | amountBrighter = 0.4f | ) | const

nodiscard noexcept

Returns a brighter version of this colour.

Parameters

  amountBrighter | how much brighter to make it - a value greater than or equal to 0, where 0 is unchanged, and higher values make it brighter

See also
  withMultipliedBrightness

References brighter(), and Colour().

Referenced by brighter().

## darker()

Colour juce::Colour::darker | ( | float | amountDarker = 0.4f | ) | const

nodiscard noexcept

Returns a darker version of this colour.

Parameters

  amountDarker | how much darker to make it - a value greater than or equal to 0, where 0 is unchanged, and higher values make it darker

See also
  withMultipliedBrightness

References Colour(), and darker().

Referenced by darker().

## contrasting() [1/3]

Colour juce::Colour::contrasting | ( | float | amount = 1.0f | ) | const

nodiscard noexcept

Returns a colour that will be clearly visible against this colour.

The amount parameter indicates how contrasting the new colour should be, so e.g. Colours::black.contrasting (0.1f) will return a colour that's just a little bit lighter; Colours::black.contrasting (1.0f) will return white; Colours::white.contrasting (1.0f) will return black, etc.

References Colour(), and contrasting().

Referenced by contrasting(), contrasting(), and contrasting().

## contrasting() [2/3]

Colour juce::Colour::contrasting | ( | Colour | targetColour,
|  | float | minLuminosityDiff ) const

nodiscard noexcept

Returns a colour that is as close as possible to a target colour whilst still being in contrast to this one.

The colour that is returned will be the targetColour, but with its luminosity nudged up or down so that it differs from the luminosity of this colour by at least the amount specified by minLuminosityDiff.

References Colour(), and contrasting().

## contrasting() [3/3]

Colour juce::Colour::contrasting | ( | Colour | colour1,
|  | Colour | colour2 )

static nodiscard noexcept

Returns a colour that contrasts against two colours.

Looks for a colour that contrasts with both of the colours passed-in. Handy for things like choosing a highlight colour in text editors, etc.

References Colour(), and contrasting().

## greyLevel()

Colour juce::Colour::greyLevel | ( | float | brightness | ) |

static nodiscard noexcept

Returns an opaque shade of grey.

Parameters

  brightness | the level of grey to return - 0 is black, 1.0 is white

References Colour(), and greyLevel().

Referenced by greyLevel().

## toString()

String juce::Colour::toString | ( |  | ) | const

Returns a stringified version of this colour.

The string can be turned back into a colour using the fromString() method.

References toString().

Referenced by toString().

## fromString()

Colour juce::Colour::fromString | ( | StringRef | encodedColourString | ) |

static nodiscard

Reads the colour from a string that was created with toString().

References Colour(), and fromString().

Referenced by fromString().

## toDisplayString()

String juce::Colour::toDisplayString | ( | bool | includeAlphaValue | ) | const

Returns the colour as a hex string in the form RRGGBB or AARRGGBB.

References toDisplayString().

Referenced by toDisplayString().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited